=== debian/changelog ===
llvm-3.1 (3.1-2ubuntu1~12.04) precise-proposed; urgency=low

  * Upload to Precise for LTS-backports-Q stack

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Wed, 28 Nov 2012 11:21:15 +1100

llvm-3.1 (3.1-2ubuntu1) quantal; urgency=low

  * Link LLVMgold.so against libLTO which was broken due to ld --as-needed.
    (LP: #1026359)
    - Add 1001-link-llvmgold-lto.diff, cherry-picked from upstream.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 27 Aug 2012 21:17:48 +0200

llvm-3.1 (3.1-2) unstable; urgency=low

  * llvm-3.1 did not include line number information recognizable by gdb
    Thanks to Ben Longbons for digging into the issue
    (Closes: #676144)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 01 Jul 2012 17:10:44 +0200

llvm-3.1 (3.1-1) unstable; urgency=low

  * New upstream release (the stable)
  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 21 May 2012 12:38:49 +0200

llvm-3.1 (3.1~+rc3-1) experimental; urgency=low

  * New upstream release
  * patches refreshed

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 20 May 2012 16:14:21 +0200
